Package org.opensaml.core.xml.io

# Interface Marshaller

All Known Implementing Classes:
  `AbstractElementExtensibleXMLObjectMarshaller`, `AbstractExtensibleXMLObjectMarshaller`, `AbstractSAMLObjectMarshaller`, `AbstractWSAddressingObjectMarshaller`, `AbstractWSPolicyObjectMarshaller`, `AbstractWSSecurityObjectMarshaller`, `AbstractWSTrustObjectMarshaller`, `AbstractXACMLObjectMarshaller`, `AbstractXMLEncryptionMarshaller`, `AbstractXMLObjectMarshaller`, `AbstractXMLSignatureMarshaller`, `ActionMarshaller`, `ActionMarshaller`, `ActionMarshaller`, `ActionMatchTypeMarshaller`, `ActionsTypeMarshaller`, `ActionTypeMarshaller`, `ActionTypeMarshaller`, `AdditionalMetadataLocationMarshaller`, `AddressMarshaller`, `AddressMarshaller`, `AdviceMarshaller`, `AdviceMarshaller`, `AffiliationDescriptorMarshaller`, `AgreementMethodMarshaller`, `AlgorithmIdentifierTypeMarshaller`, `AllMarshaller`, `AllowPostdatingMarshaller`, `AppliesToMarshaller`, `AppliesToMarshaller`, `ApplyTypeMarshaller`, `ArtifactResolveMarshaller`, `ArtifactResponseMarshaller`, `AssertionIDRequestMarshaller`, `AssertionMarshaller`, `AssertionMarshaller`, `AsynchronousMarshaller`, `AttributeAssignmentTypeMarshaller`, `AttributeAuthorityDescriptorMarshaller`, `AttributeConsumingServiceMarshaller`, `AttributedDateTimeMarshaller`, `AttributeDesignatorMarshaller`, `AttributeDesignatorTypeMarshaller`, `AttributedQNameMarshaller`, `AttributedStringMarshaller`, `AttributedUnsignedLongMarshaller`, `AttributedURIMarshaller`, `AttributedURIMarshaller`, `AttributeMarshaller`, `AttributeMarshaller`, `AttributeQueryDescriptorTypeMarshaller`, `AttributeQueryMarshaller`, `AttributeQueryMarshaller`, `AttributeSelectorTypeMarshaller`, `AttributeStatementMarshaller`, `AttributeStatementMarshaller`, `AttributeTypeMarshaller`, `AttributeValueTypeMarshaller`, `AttributeValueTypeMarshaller`, `AudienceRestrictionConditionMarshaller`, `AudienceRestrictionMarshaller`, `AuthenticationQueryMarshaller`, `AuthenticationStatementMarshaller`, `AuthenticationTypeMarshaller`, `AuthenticatorMarshaller`, `AuthnAuthorityDescriptorMarshaller`, `AuthnContextMarshaller`, `AuthnQueryDescriptorTypeMarshaller`, `AuthnQueryMarshaller`, `AuthnRequestMarshaller`, `AuthnStatementMarshaller`, `AuthorityBindingMarshaller`, `AuthorizationDecisionQueryMarshaller`, `AuthorizationDecisionStatementMarshaller`, `AuthzDecisionQueryDescriptorTypeMarshaller`, `AuthzDecisionQueryMarshaller`, `AuthzDecisionStatementMarshaller`, `BaseIDMarshaller`, `BinaryExchangeMarshaller`, `BinarySecretMarshaller`, `BinarySecurityTokenMarshaller`, `BodyMarshaller`, `CancelTargetMarshaller`, `CanonicalizationAlgorithmMarshaller`, `ChallengeMarshaller`, `ChannelBindingsMarshaller`, `CipherDataMarshaller`, `CipherReferenceMarshaller`, `ClaimsMarshaller`, `CodeMarshaller`, `CombinedHashMarshaller`, `CombinerParametersTypeMarshaller`, `CombinerParameterTypeMarshaller`, `ComputedKeyAlgorithmMarshaller`, `ComputedKeyMarshaller`, `ConcatKDFParamsMarshaller`, `ConditionsMarshaller`, `ConditionsMarshaller`, `ConditionTypeMarshaller`, `ContactPersonMarshaller`, `CreatedMarshaller`, `CryptoBinaryMarshaller`, `DataReferenceMarshaller`, `DecisionTypeMarshaller`, `DefaultsTypeMarshaller`, `DelegatableMarshaller`, `DelegateMarshaller`, `DelegateToMarshaller`, `DelegationRestrictionTypeMarshaller`, `DEREncodedKeyValueMarshaller`, `DerivedKeyMarshaller`, `DescriptionTypeMarshaller`, `DetailMarshaller`, `DHKeyValueMarshaller`, `DigestMethodMarshaller`, `DigestMethodMarshaller`, `DiscoHintsMarshaller`, `DoNotCacheConditionMarshaller`, `DSAKeyValueMarshaller`, `ECKeyValueMarshaller`, `EmbeddedMarshaller`, `EncodedStringMarshaller`, `EncryptedAssertionMarshaller`, `EncryptedAttributeMarshaller`, `EncryptedDataMarshaller`, `EncryptedElementTypeMarshaller`, `EncryptedHeaderMarshaller`, `EncryptedIDMarshaller`, `EncryptedKeyMarshaller`, `EncryptedTypeMarshaller`, `EncryptionAlgorithmMarshaller`, `EncryptionMarshaller`, `EncryptionMethodMarshaller`, `EncryptionPropertiesMarshaller`, `EncryptionPropertyMarshaller`, `EncryptWithMarshaller`, `EndpointMarshaller`, `EndpointReferenceMarshaller`, `EndPointReferenceMarshaller`, `EndpointReferenceTypeMarshaller`, `EntitiesDescriptorMarshaller`, `EntityAttributesMarshaller`, `EntityDescriptorMarshaller`, `EntropyMarshaller`, `EnvelopeMarshaller`, `EnvironmentMatchTypeMarshaller`, `EnvironmentsTypeMarshaller`, `EnvironmentTypeMarshaller`, `EnvironmentTypeMarshaller`, `EvidenceMarshaller`, `EvidenceMarshaller`, `ExactlyOneMarshaller`, `ExpiresMarshaller`, `ExtensionsMarshaller`, `ExtensionsMarshaller`, `FaultMarshaller`, `FaultToMarshaller`, `ForwardableMarshaller`, `FromMarshaller`, `FunctionTypeMarshaller`, `GeneratedKeyMarshaller`, `HeaderMarshaller`, `IDPEntryMarshaller`, `IDPListMarshaller`, `IDPSSODescriptorMarshaller`, `IdReferenceTypeMarshaller`, `IndexedEndpointMarshaller`, `IssuedTokensMarshaller`, `IssuerMarshaller`, `IterationMarshaller`, `KeyDerivationMethodMarshaller`, `KeyDescriptorMarshaller`, `KeyExchangeTokenMarshaller`, `KeyIdentifierMarshaller`, `KeyInfoMarshaller`, `KeyInfoReferenceMarshaller`, `KeyReferenceMarshaller`, `KeySizeMarshaller`, `KeyTypeMarshaller`, `KeyValueMarshaller`, `KeywordsMarshaller`, `KeyWrapAlgorithmMarshaller`, `LifetimeMarshaller`, `LocalizedNameMarshaller`, `LocalizedURIMarshaller`, `LogoMarshaller`, `LogoutRequestMarshaller`, `LogoutResponseMarshaller`, `ManageNameIDRequestMarshaller`, `ManageNameIDResponseMarshaller`, `MessageIDMarshaller`, `MetadataMarshaller`, `MGFMarshaller`, `MissingAttributeDetailTypeMarshaller`, `NamedCurveMarshaller`, `NameIdentifierMarshaller`, `NameIDMappingRequestMarshaller`, `NameIDMappingResponseMarshaller`, `NameIDPolicyMarshaller`, `NameIDTypeMarshaller`, `NewEncryptedIDMarshaller`, `NonceMarshaller`, `ObligationsTypeMarshaller`, `ObligationTypeMarshaller`, `OnBehalfOfMarshaller`, `OneTimeUseMarshaller`, `OperatorContentTypeMarshaller`, `OrganizationMarshaller`, `OriginatorKeyInfoMarshaller`, `OtherSourceMarshaller`, `ParticipantMarshaller`, `ParticipantsMarshaller`, `ParticipantTypeMarshaller`, `PasswordMarshaller`, `PBKDF2ParamsMarshaller`, `PDPDescriptorMarshaller`, `PGPDataMarshaller`, `PolicyAttachmentMarshaller`, `PolicyCombinerParametersTypeMarshaller`, `PolicyMarshaller`, `PolicyReferenceMarshaller`, `PolicySetCombinerParametersTypeMarshaller`, `PolicySetTypeMarshaller`, `PolicyTypeMarshaller`, `PRFMarshaller`, `PrimaryMarshaller`, `ProblemActionMarshaller`, `ProblemHeaderQNameMarshaller`, `ProblemIRIMarshaller`, `ProofEncryptionMarshaller`, `ProxyRestrictionMarshaller`, `PublicationInfoMarshaller`, `PublicationMarshaller`, `PublicationPathMarshaller`, `QueryDescriptorTypeMarshaller`, `ReasonMarshaller`, `RecipientKeyInfoMarshaller`, `ReferencedPoliciesTypeMarshaller`, `ReferenceListMarshaller`, `ReferenceMarshaller`, `ReferenceParametersMarshaller`, `ReferenceTypeMarshaller`, `RegistrationInfoMarshaller`, `RelatesToMarshaller`, `RelayStateMarshaller`, `RenewingMarshaller`, `RenewTargetMarshaller`, `ReplyToMarshaller`, `RequestAbstractTypeMarshaller`, `RequestAbstractTypeMarshaller`, `RequestAuthenticatedMarshaller`, `RequestedAttachedReferenceMarshaller`, `RequestedAttributeMarshaller`, `RequestedAttributesMarshaller`, `RequestedAuthnContextMarshaller`, `RequestedProofTokenMarshaller`, `RequestedReferenceTypeMarshaller`, `RequestedSecurityTokenMarshaller`, `RequestedSecurityTokenMarshaller`, `RequestedTokenCancelledMarshaller`, `RequestedUnattachedReferenceMarshaller`, `RequestKETMarshaller`, `RequestMarshaller`, `RequestMarshaller`, `RequestSecurityTokenCollectionMarshaller`, `RequestSecurityTokenMarshaller`, `RequestSecurityTokenResponseCollectionMarshaller`, `RequestSecurityTokenResponseMarshaller`, `RequestSecurityTokenResponseMarshaller`, `RequestTypeMarshaller`, `RequestTypeMarshaller`, `ResourceContentTypeMarshaller`, `ResourceMatchTypeMarshaller`, `ResourcesTypeMarshaller`, `ResourceTypeMarshaller`, `ResourceTypeMarshaller`, `ResponseAbstractTypeMarshaller`, `ResponseMarshaller`, `ResponseMarshaller`, `ResponseMarshaller`, `ResponseTypeMarshaller`, `ResultTypeMarshaller`, `RetrievalMethodMarshaller`, `RetryAfterMarshaller`, `RoleDescriptorMarshaller`, `RSAKeyValueMarshaller`, `RuleCombinerParametersTypeMarshaller`, `RuleTypeMarshaller`, `SaltMarshaller`, `SaltMarshaller`, `ScopingMarshaller`, `SecurityMarshaller`, `SecurityTokenReferenceMarshaller`, `SessionKeyMarshaller`, `SignatureAlgorithmMarshaller`, `SignatureConfirmationMarshaller`, `SignatureMarshaller`, `SignChallengeMarshaller`, `SignChallengeResponseMarshaller`, `SignChallengeTypeMarshaller`, `SigningMethodMarshaller`, `SignWithMarshaller`, `SimpleXMLObjectMarshaller`, `SoapActionMarshaller`, `SPKIDataMarshaller`, `SPSSODescriptorMarshaller`, `SSODescriptorMarshaller`, `StatusCodeMarshaller`, `StatusCodeMarshaller`, `StatusCodeTypeMarshaller`, `StatusDetailMarshaller`, `StatusDetailMarshaller`, `StatusDetailTypeMarshaller`, `StatusMarshaller`, `StatusMarshaller`, `StatusMarshaller`, `StatusMessageTypeMarshaller`, `StatusResponseTypeMarshaller`, `StatusTypeMarshaller`, `SubjectAttributeDesignatorTypeMarshaller`, `SubjectConfirmationDataMarshaller`, `SubjectConfirmationMarshaller`, `SubjectConfirmationMarshaller`, `SubjectConfirmationMarshaller`, `SubjectLocalityMarshaller`, `SubjectLocalityMarshaller`, `SubjectMarshaller`, `SubjectMarshaller`, `SubjectMatchTypeMarshaller`, `SubjectQueryMarshaller`, `SubjectQueryMarshaller`, `SubjectStatementMarshaller`, `SubjectsTypeMarshaller`, `SubjectTypeMarshaller`, `SubjectTypeMarshaller`, `TargetTypeMarshaller`, `TerminateMarshaller`, `TimestampMarshaller`, `TokenTypeMarshaller`, `ToMarshaller`, `TransformationParametersMarshaller`, `TransformMarshaller`, `TransformsMarshaller`, `TransformsMarshaller`, `UIInfoMarshaller`, `UseKeyMarshaller`, `UsernameMarshaller`, `UsernameTokenMarshaller`, `ValidateTargetMarshaller`, `VariableDefinitionTypeMarshaller`, `VariableReferenceTypeMarshaller`, `X509DataMarshaller`, `X509DigestMarshaller`, `X509IssuerSerialMarshaller`, `X509SerialNumberMarshaller`, `XACMLAuthzDecisionQueryTypeMarshaller`, `XACMLAuthzDecisionStatementTypeMarshaller`, `XACMLPolicyQueryTypeMarshaller`, `XACMLPolicyStatementTypeMarshaller`, `XSAnyMarshaller`, `XSBase64BinaryMarshaller`, `XSBooleanMarshaller`, `XSDateTimeMarshaller`, `XSIntegerMarshaller`, `XSQNameMarshaller`, `XSStringMarshaller`, `XSURIMarshaller`

public interface Marshaller
Marshallers are used to marshall a `XMLObject` into a W3C DOM element.

## Method Summary

Modifier and Type
Method
Description
`Element`
`marshall(XMLObject xmlObject)`
Marshall this element, and its children, and root them in a newly created Document.
`Element`
`marshall(XMLObject xmlObject, Document document)`
Marshall this element, and its children, into a W3C DOM element.
`Element`
`marshall(XMLObject xmlObject, Element parentElement)`
Marshall the given XMLObject and append it as a child to the given parent element.

## Method Details

### marshall

@Nonnull Element marshall(@Nonnull XMLObject xmlObject) throws MarshallingException
Marshall this element, and its children, and root them in a newly created Document. The Document is created by a `DocumentBuilder` obtained from a `DocumentBuilderFactory` created without any additional parameters or properties set; that is the system defaults properties are used.

Parameters:
  `xmlObject` - the object to marshall
Returns:
  the W3C DOM element representing this SAML element
Throws:
  `MarshallingException` - thrown if there is a problem marshalling the given object

### marshall

@Nonnull Element marshall(@Nonnull XMLObject xmlObject, @Nonnull Document document) throws MarshallingException
Marshall this element, and its children, into a W3C DOM element. If the document does not have a Document Element the Element resulting from this marshalling will be set as the Document Element.

Parameters:
  `xmlObject` - the object to marshall
  `document` - the DOM document the marshalled element will be placed in
Returns:
  the W3C DOM element representing this XMLObject
Throws:
  `MarshallingException` - thrown if there is a problem marshalling the given object

### marshall

@Nonnull Element marshall(@Nonnull XMLObject xmlObject, @Nonnull Element parentElement) throws MarshallingException
Marshall the given XMLObject and append it as a child to the given parent element. NOTE: The given Element must be within a DOM tree whose root is the root of the Document owning the given Element.

Parameters:
  `xmlObject` - the XMLObject to be marshalled
  `parentElement` - the parent of the Element resulting from marshalling the given XMLObject
Returns:
  the marshalled XMLObject
Throws:
  `MarshallingException` - thrown if the given XMLObject can not be marshalled.